#include <stdlib.h>
#include "bool.h"

#define MAXLISTLENGTH 8 // prevent memory overflows -- limited RAM

typedef unsigned long datum_t;

struct ListNode {
    struct ListNode * next;
    volatile datum_t datum;
};

struct List {
    struct ListNode *head,
                    *tail;
    int length;
};

struct ListEnum {
    struct ListNode *pointer;
    int index;
    bool hasNext;
    volatile datum_t value;
};

struct List * makeList(void);
void appendToList(struct List *list, datum_t num);
void killList(struct List **list); // Must call with killList(&myList);

struct ListEnum * makeEnum(struct List *list);
datum_t nextDatum(struct ListEnum *lEnum);


struct ListNode * makeListNode(datum_t num);
void insertAfter(struct ListNode *first, struct ListNode *next);

